/***********************************************************************/
/*                                                                     */
/*  FILE        :f1mini.c                                              */
/*  DATE        :Wed, Apr 26, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8/3687                                               */
/*                                                                     */
/*  This file is programed by TOYO-LINX Co.,Ltd. / yKikuchi            */
/*                                                                     */
/***********************************************************************/

/************************************************************************
	vO̓e
************************************************************************/
/*
dICSW2ƃg[XJnB
ɔ̃Cg[XB
COꂽƂ͌ށCCTčĂуg[XB
^b`XCb`IŒ~B
SW3ȂdI]`FbNvOB
SW4ȂdIPWM`FbNvOB
*/

/************************************************************************
	CN[ht@C
************************************************************************/
#include	<machine.h>		// H8L̖߂g
#include	"iodefine.h"	// I/Õx`

/************************************************************************
	萔̒`iڎwj
************************************************************************/
#define		OK			0		//߂l
#define		NG			-1		//߂l

#define		TL3LP		8		//,},[^,%
#define		TL3RP		20		//,},E[^,%
#define		TL2LP		12		//,,[^,%
#define		TL2RP		20		//,,E[^,%
#define		TL1LP		16		//,,[^,%
#define		TL1RP		20		//,,E[^,%

#define		CW4LP		20		//i,4,[^,%
#define		CW4RP		20		//i,4,E[^,%
#define		CW3LP		16		//i,3,[^,%
#define		CW3RP		16		//i,3,E[^,%
#define		CW2LP		12		//i,2,[^,%
#define		CW2RP		12		//i,2,E[^,%
#define		CW1LP		8		//i,1,[^,%
#define		CW1RP		8		//i,1,E[^,%

#define		TR1LP		20		//E,,[^,%
#define		TR1RP		16		//E,,E[^,%
#define		TR2LP		20		//E,,[^,%
#define		TR2RP		12		//E,,E[^,%
#define		TR3LP		20		//E,},[^,%
#define		TR3RP		8		//E,},E[^,%

/************************************************************************
	萔GA̒`(ROM)
************************************************************************/
// 7ZOgf[^ϊe[u ----------------------------------------
const unsigned char	SegTable[]	=	{0x3f,0x06,0x5b,0x4f,	//0,1,2,3
									 0x66,0x6d,0x7d,0x07,	//4,5,6,7
									 0x7f,0x6f,0x77,0x7c,	//8,9,A,B
									 0x39,0x5e,0x79,0x71	//C,D,E,F
									};

/************************************************************************
	O[oϐ̒`ƃCjVCY(RAM)
************************************************************************/
// vOɊւϐ -------------------------------------------
unsigned char	ProgNo		=	0;	//vOio[
unsigned char	ProgStage	=	0;	//vOXe[Wio[

// XCb`͂Ɋ֌Wϐ -------------------------------------------
unsigned char	SwData1		=	0;	//t@[Xg[h
unsigned char	SwData2		=	0;	//_u[hɂ茈肵f[^
unsigned char	SwData3		=	0;	//Õ_u[hŌ肵f[^
unsigned char	SwData4		=	0;	//01ɕωf[^
unsigned char	SwStatus	=	0;	//XCb`̓Xe[^X
									// 0:t@[Xg[h
									// 1:_u[h

// Cg[XɊւϐ -------------------------------------------
unsigned char	LineData	=	0;	//C
unsigned char	OldLineData	=	0;	//ÕC

//,},[^
unsigned int	TurnLeft3L	=	0xffff - ((unsigned long)0xffff * TL3LP / 100);
//,},E[^
unsigned int	TurnLeft3R	=	0xffff - ((unsigned long)0xffff * TL3RP / 100);
//,,[^
unsigned int	TurnLeft2L	=	0xffff - ((unsigned long)0xffff * TL2LP / 100);
//,,E[^
unsigned int	TurnLeft2R	=	0xffff - ((unsigned long)0xffff * TL2RP / 100);
//,,[^
unsigned int	TurnLeft1L	=	0xffff - ((unsigned long)0xffff * TL1LP / 100);
//,,E[^
unsigned int	TurnLeft1R	=	0xffff - ((unsigned long)0xffff * TL1RP / 100);

//i,4,[^
unsigned int	Cw4L		=	0xffff - ((unsigned long)0xffff * CW4LP / 100);
//i,4,E[^
unsigned int	Cw4R		=	0xffff - ((unsigned long)0xffff * CW4RP / 100);
//i,3,[^
unsigned int	Cw3L		=	0xffff - ((unsigned long)0xffff * CW3LP / 100);
//i,3,E[^
unsigned int	Cw3R		=	0xffff - ((unsigned long)0xffff * CW3RP / 100);
//i,2,[^
unsigned int	Cw2L		=	0xffff - ((unsigned long)0xffff * CW2LP / 100);
//i,2,E[^
unsigned int	Cw2R		=	0xffff - ((unsigned long)0xffff * CW2RP / 100);
//i,1,[^
unsigned int	Cw1L		=	0xffff - ((unsigned long)0xffff * CW1LP / 100);
//i,1,E[^
unsigned int	Cw1R		=	0xffff - ((unsigned long)0xffff * CW1RP / 100);

//E,,[^
unsigned int	TurnRight1L	=	0xffff - ((unsigned long)0xffff * TR1LP / 100);
//E,,E[^
unsigned int	TurnRight1R	=	0xffff - ((unsigned long)0xffff * TR1RP / 100);
//E,,[^
unsigned int	TurnRight2L	=	0xffff - ((unsigned long)0xffff * TR2LP / 100);
//E,,E[^
unsigned int	TurnRight2R	=	0xffff - ((unsigned long)0xffff * TR2RP / 100);
//E,},[^
unsigned int	TurnRight3L	=	0xffff - ((unsigned long)0xffff * TR3LP / 100);
//E,},E[^
unsigned int	TurnRight3R	=	0xffff - ((unsigned long)0xffff * TR3RP / 100);

/************************************************************************
	֐̒`
************************************************************************/
void		ccw1(void);				//,1
void		ccw2(void);				//,2
void		ccw3(void);				//,3
void		ccw4(void);				//,4
void		chk_cw_ccw(void);		//]mFvO
void		chk_pwm(void);			//PWMmFvO
void		cw1(void);				//Oi,1
void		cw2(void);				//Oi,2
void		cw3(void);				//Oi,3
void		cw4(void);				//Oi,4
void		init_io(void);			//IO|[gCjVCY
void		init_tmb1(void);		//^C}B1CjVCY
void		init_tmz(void);			//^C}ZCjVCY
void		intprog_tmb1(void);		//^C}B1
void		main(void);				//CvO
void		stop(void);				//~
void		switch_in(void);		//XCb`
void		trace(void);			//Cg[X
void		turn_left_1(void);		//ij
void		turn_left_2(void);		//ij
void		turn_left_3(void);		//ij
void		turn_right_1(void);		//Eij
void		turn_right_2(void);		//Eij
void		turn_right_3(void);		//Eij

/************************************************************************
	CvO
************************************************************************/
void main(void)
{
	// CjVCY ----------------------------------------------------
	init_io();
	init_tmb1();
	init_tmz();

	// `FbN[`ɃWv -----------------------------------------
	if (IO.PDR5.BIT.B2==0){
		while(1) {chk_cw_ccw();}
	}
	if (IO.PDR5.BIT.B3==0){
		while(1) {chk_pwm();}
	}
		
	// C[v ------------------------------------------------------
	while(1){
		trace();
	}
}

/************************************************************************
	Cg[X
************************************************************************/
void trace(void)
{
	switch (ProgStage){
		// X^[g҂ --------------------------------------------------
		case 0:
			if ((SwData4 & 0x02)!=0){	//SW2ꂽ烉Cg[XsX^[g
				ProgStage = 1;
				SwData4 = 0;
			}
			IO.PDR3.BYTE = ~SegTable[0];
			break;
		// Cg[Xs --------------------------------------------
		case 1:
			LineData = ~IO.PDR1.BYTE & 0xf0;
			switch (LineData){
				case 0x80:	//ijEij
					turn_right_3();
					IO.PDR3.BYTE = ~SegTable[1];
					break;
				case 0xc0:	//ijEij
					turn_right_2();
					IO.PDR3.BYTE = ~SegTable[2];
					break;
				case 0x40:	//ijEij
					turn_right_1();
					IO.PDR3.BYTE = ~SegTable[3];
					break;
				case 0x60:	//Oi
					cw4();
					IO.PDR3.BYTE = ~SegTable[4];
					break;
				case 0x20:	//Eijij
					turn_left_1();
					IO.PDR3.BYTE = ~SegTable[5];
					break;
				case 0x30:	//Eijij
					turn_left_2();
					IO.PDR3.BYTE = ~SegTable[6];
					break;
				case 0x10:	//Eijij
					turn_left_3();
					IO.PDR3.BYTE = ~SegTable[7];
					break;
				default:	//ȊO
					ccw2();
					IO.PDR3.BYTE = ~SegTable[8];
					break;
			}

			if ((IO.PDR1.BIT.B0==0)||(IO.PDR1.BIT.B1==0)){
				stop();			//Ԃ~
				ProgStage = 0;	//XCb`҂ɖ߂
			}

			break;
	}
}

/************************************************************************
	[^Xs[hZbg
************************************************************************/
// Oi,1 -------------------------------------------------------------
void cw1(void)
{
	TZ0.GRC = Cw1L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = Cw1R;
	TZ1.GRD = 0xffff;
}

// Oi,2 -------------------------------------------------------------
void cw2(void)
{
	TZ0.GRC = Cw2L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = Cw2R;
	TZ1.GRD = 0xffff;
}

// Oi,3 -------------------------------------------------------------
void cw3(void)
{
	TZ0.GRC = Cw3L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = Cw3R;
	TZ1.GRD = 0xffff;
}

// Oi,4 -------------------------------------------------------------
void cw4(void)
{
	TZ0.GRC = Cw4L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = Cw4R;
	TZ1.GRD = 0xffff;
}

// ,1 -------------------------------------------------------------
void ccw1(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw1L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw1R;
}

// ,2 -------------------------------------------------------------
void ccw2(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw2L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw2R;
}

// ,3 -------------------------------------------------------------
void ccw3(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw3L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw3R;
}

// ,4 -------------------------------------------------------------
void ccw4(void)
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = Cw4L;
	TZ1.GRC = 0xffff;
	TZ1.GRD = Cw4R;
}

// Eij ---------------------------------------------------------
void turn_right_1(void)
{
	TZ0.GRC = TurnRight1L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnRight1R;
	TZ1.GRD = 0xffff;
}

// Eij ---------------------------------------------------------
void turn_right_2(void)
{
	TZ0.GRC = TurnRight2L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnRight2R;
	TZ1.GRD = 0xffff;
}

// Eij ---------------------------------------------------------
void turn_right_3(void)
{
	TZ0.GRC = TurnRight3L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnRight3R;
	TZ1.GRD = 0xffff;
}

// ij ---------------------------------------------------------
void turn_left_1(void)
{
	TZ0.GRC = TurnLeft1L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnLeft1R;
	TZ1.GRD = 0xffff;
}

// ij ---------------------------------------------------------
void turn_left_2(void)
{
	TZ0.GRC = TurnLeft2L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnLeft2R;
	TZ1.GRD = 0xffff;
}

// ij ---------------------------------------------------------
void turn_left_3(void)
{
	TZ0.GRC = TurnLeft3L;
	TZ0.GRD = 0xffff;
	TZ1.GRC = TurnLeft3R;
	TZ1.GRD = 0xffff;
}

// ~ -----------------------------------------------------------------
void stop()
{
	TZ0.GRC = 0xffff;
	TZ0.GRD = 0xffff;
	TZ1.GRC = 0xffff;
	TZ1.GRD = 0xffff;
}

/************************************************************************
	]̊mFvO
************************************************************************/
void chk_cw_ccw(void)
{
	IO.PCR6 = 0xcc;	//|[g6,P62,63,66,67o,P60,61,64,65

	if (IO.PDR5.BIT.B0==0)	{IO.PDR6.BIT.B7 = 1;}	//SW1-On : E
	else					{IO.PDR6.BIT.B7 = 0;}

	if (IO.PDR5.BIT.B1==0)	{IO.PDR6.BIT.B6 = 1;}	//SW2-On : EOi
	else					{IO.PDR6.BIT.B6 = 0;}

	if (IO.PDR5.BIT.B2==0)	{IO.PDR6.BIT.B3 = 1;}	//SW3-On : 
	else					{IO.PDR6.BIT.B3 = 0;}

	if (IO.PDR5.BIT.B3==0)	{IO.PDR6.BIT.B2 = 1;}	//SW4-On : Oi
	else					{IO.PDR6.BIT.B2 = 0;}
}

/************************************************************************
	PWM̊mFvO
************************************************************************/
void chk_pwm(void)
{
	unsigned long i;

	if (IO.PDR5.BIT.B0==0){		//SW1-On : E
		if (TZ1.GRC==0xffff){
			if (TZ1.GRD!=0x0000) {TZ1.GRD = TZ1.GRD - 1;}
		}
		else{
			TZ1.GRC = TZ1.GRC + 1;
		}
	}

	if (IO.PDR5.BIT.B1==0){		//SW2-On : E
		if (TZ1.GRD==0xffff){
			if (TZ1.GRC!=0x0000) {TZ1.GRC = TZ1.GRC - 1;}
		}
		else{
			TZ1.GRD = TZ1.GRD + 1;
		}
	}

	if (IO.PDR5.BIT.B2==0){		//SW3-On : 
		if (TZ0.GRC==0xffff){
			if (TZ0.GRD!=0x0000) {TZ0.GRD = TZ0.GRD - 1;}
		}
		else{
			TZ0.GRC = TZ0.GRC + 1;
		}
	}

	if (IO.PDR5.BIT.B3==0){		//SW4-On : 
		if (TZ0.GRD==0xffff){
			if (TZ0.GRC!=0x0000) {TZ0.GRC = TZ0.GRC - 1;}
		}
		else{
			TZ0.GRD = TZ0.GRD + 1;
		}
	}

	IO.PDR3.BYTE = ~SegTable[TZ1.GRC / 0x1000];	//EOȉԂ\
//	IO.PDR3.BYTE = ~SegTable[TZ1.GRD / 0x1000];	//Eނ̏Ԃ\
//	IO.PDR3.BYTE = ~SegTable[TZ0.GRC / 0x1000];	//EOȉԂ\
//	IO.PDR3.BYTE = ~SegTable[TZ0.GRD / 0x1000];	//Eނ̏Ԃ\

	for (i=0;i<200;i++){}
}

/************************************************************************
	I/O|[g CjVCY
************************************************************************/
void init_io(void)
{
	IO.PMR1.BYTE	=	0x00;	//|[g1,ėpo̓|[g
	IO.PUCR1.BYTE	=	0x00;	//|[g1,vAbvIt
	IO.PCR1			=	0x00;	//|[g1,P10-17

	IO.PDR3.BYTE	=	0xff;	//|[g3,o
	IO.PCR3			=	0xff;	//|[g3,P30-37o

	IO.PMR5.BYTE	=	0x00;	//|[g5,ėpo̓|[g
	IO.PUCR5.BYTE	=	0x0f;	//|[g5,P50-53vAbvI
	IO.PDR5.BYTE	=	0x10;	//|[g5,o
	IO.PCR5			=	0x10;	//|[g5,P54o,P50-53,P55-57

	IO.PCR6			=	0x00;	//|[g6,P60-67
}

/************************************************************************
	^C}Z CjVCY
************************************************************************/
void init_tmz(void)
{
	TZ.TSTR.BYTE	=	0x00;	//TCNT0,1 ~

	TZ0.TCR.BYTE	=	0x20;	//GRÃRyA}b`TCNT=0,/1
	TZ1.TCR.BYTE	=	0x20;	//GRÃRyA}b`TCNT=0,/1

	TZ.TPMR.BYTE	=	0x66;	//FTIOC0,FTIOD0,FTIOC1,FTIOD1 PWM[h
	TZ.TOCR.BYTE	=	0x00;	//o,All Low

	TZ0.POCR.BYTE	=	0x06;	//FTIOC0,FTIOD0 o̓nCANeBu
	TZ1.POCR.BYTE	=	0x06;	//FTIOC1,FTIOD1 o̓nCANeBu

	TZ0.GRA			=	0xfffe;	//PWM (65534*(1/20MHz)=3.2767ms)
	TZ1.GRA			=	0xfffe;	//PWM (65534*(1/20MHz)=3.2767ms)
	TZ0.GRC			=	0xffff;	//FTIOC0=Low
	TZ1.GRC			=	0xffff;	//FTIOC1=Low
	TZ0.GRD			=	0xffff;	//FTIOD0=Low
	TZ1.GRD			=	0xffff;	//FTIOD1=Low

	TZ.TOER.BYTE	=	0x33;	//FTIOC0,DTIOD0.FTIOC1,FTIOD1 o͋

	TZ0.TCNT		=	0x0000;	//TCNT0=0
	TZ1.TCNT		=	0x0000;	//TCNT1=0
	TZ.TSTR.BYTE	=	0x03;	//TCNT0 JEgX^[g
}

/************************************************************************
	^C}B1 CjVCY
************************************************************************/
void init_tmb1(void)
{
	TB1.TMB1.BYTE		=	0xf9;	//I[g[hCNbN/2048
	TB1.TLB1			=	0-97;	//=10ms(100Hz)
	IRR2.BIT.IRRTB1		=	0;		//^C}B1ݗvtO NA
	IENR2.BIT.IENTB1	=	1;		//^C}B1ݗvCl[u
}

/************************************************************************
	^C}B1 (10ms)
************************************************************************/
#pragma regsave (intprog_tmb1)
void intprog_tmb1(void)
{
	//^C}B1ݗvtO NA
	IRR2.BIT.IRRTB1 = 0;

	//XCb`
	switch_in();
}

/************************************************************************
	XCb`
************************************************************************/
void switch_in(void)
{
	switch(SwStatus){
		case 0:
			SwData1 = ~IO.PDR5.BYTE & 0x0f;
			if (SwData1!=0)	{SwStatus = 1;}
			else			{SwData2 = SwData3 =0;}
			break;
		case 1:
			if (SwData1==(~IO.PDR5.BYTE & 0x0f)){
				SwData2 = SwData1;
				SwData4 = SwData4 | (SwData2 & (~SwData3));
				SwData3 = SwData2;
			}
			SwStatus = 0;
			break;
	}
}
